	AREA wram_code1, CODE, READWRITE

	INCLUDE equates.h
	INCLUDE z80mac.h
	INCLUDE z80.h
	INCLUDE io.h
	INCLUDE gfx.h

	IMPORT ui	;ui.c

	EXPORT CPU_reset
	EXPORT run
	EXPORT sleeptime
	EXPORT dontstop
	EXPORT novblankwait
	EXPORT gbadetect
	EXPORT sprcollision
	EXPORT ntsc_pal_reset



;----------------------------------------------------------------------------
run	;r0=0 to return after frame
;----------------------------------------------------------------------------
;	mov r11,r11					;@ No$GBA breakpoint
	mov r1,#0
	strb r1,novblankwait

	strb r0,dontstop
	tst r0,#1
	stmeqfd sp!,{r4-r11,lr}

	ldr globalptr,=|wram_globals1$$Base|
	b line0x
;----------------------------------------------------------------------------
;cycles ran out
;----------------------------------------------------------------------------
line0
	adr r2,z80_regs
	stmia r2,{z80f-z80pc,z80sp}	;@ save Z80 state
waitformulti
	ldr r1,=REG_P1				;@ refresh input every frame
	ldrh r0,[r1]
		eor r0,r0,#0xff
		eor r0,r0,#0x300		;@ r0=button state (raw)
	ldr r1,AGBjoypad
	eor r1,r1,r0
	and r1,r1,r0				;@ r1=button state (0->1)
	str r0,AGBjoypad

	ldrb r2,emuflags+1
	cmp r2,#SCALED
	bhs %F0						;@ if unscaled
	ldr r2,windowtop
	ldrb r3,maxpan
	tst r0,#0x100				;@ R=scroll down
	addne r2,r2,#2
	cmp r2,r3
	movgt r2,r3
	ldrb r3,minpan
	tst r0,#0x200				;@ L=scroll up
	subne r2,r2,#2
	cmp r2,r3
	movmi r2,r3
	str r2,windowtop
0

	ldrb r2,dontstop
	tst r2,#1
	ldmeqfd sp!,{r4-r11,lr}		;@ exit here if doing single frame:
	bxeq lr						;@ return to rommenu()

	;----anything from here til line0x won't get executed while rom menu is active---

	mov r2,#REG_BASE
	ldrb r3,emuflags+1
	cmp r3,#SCALED
	movmi r3,#0
	ldrpl r3,=0x2243			;@ was 0x2241
	strh r3,[r2,#REG_BLDCNT]	;@ stop darkened screen,OBJ blend to BG0/1
;	mov r3,#0x1000				;@ BG0/1=16, OBJ=0
;	strh r3,[r2,#REG_BLDALPHA]	;@ Alpha values

	adr lr,line0x				;@ return here after doing L/R + SEL/START

	tst r1,#0x300				;@ if L or R was pressed
	tstne r0,#0x100
	tstne r0,#0x200				;@ and both L+R are held..
	ldrne r1,=ui
	bxne r1						;@ do menu


	ands r3,r0,#0x300			;@ if either L or R is pressed (not both)
	eornes r3,r3,#0x300
	bicne r0,r0,#0x0c			;@ hide sel,start from EMU
	str r0,EMUjoypad
	beq line0x					;@ skip ahead if neither or both are pressed

	tst r0,#0x200
	tstne r1,#4					;@ L+SEL for BG adjust
	blne AdjustSet

	tst r0,#0x200				;@ L?
	tstne r1,#8					;@ START?
	ldrb r2,novblankwait		;@ 0=Normal, 1=Force, 2=No wait, 3=Slomo
	addne r2,r2,#1
	and r2,r2,#3
	strb r2,novblankwait

	tst r0,#0x100				;@ R?
	tstne r1,#8					;@ START:
	ldrneb r1,keyb_on
	eor r1,r1,#2
	strneb r1,keyb_on

;	ldrne r1,=showkeyboard
;	bxne r1

;	tst r0,#0x100				;@ R?
;	tstne r1,#4					;@ SELECT:
;	ldrne r1,=quicksave
;	bxne r1
line0x
	bl refreshEMUjoypads		;@ Z=1 if communication ok
	bne waitformulti			;@ waiting on other GBA..

	ldr r0,AGBjoypad
	ldr r2,fiveminutes			;@ sleep after 5/10/30 minutes of inactivity
	cmp r0,#0					;@ (left out of the loop so waiting on multi-link
	ldrne r2,sleeptime			;@ doesn't accelerate time)
	subs r2,r2,#1
	str r2,fiveminutes
	bleq suspend

	bl newframe					;@ display update

	adr r0,z80_regs
	ldmia r0,{z80f-z80pc,z80sp}	;@ restore Z80 state

;	ldr r0,cyclesperscanline
;	add cycles,cycles,r0
	adr r0,line0_to_96
	str r0,z80_nexttimeout
	str r0,z80_nexttimeout_
;	mov r1,#0					;@ Scanline

line0_to_96 ;------------------------
	ldr r0,cyclesperscanline
	add cycles,cycles,r0

	ldr r1,scanline
	add r1,r1,#1
	str r1,scanline

	cmp r1,#30
	ldreqb r0,vdpstat
	ldreqb r2,sprcollision
	orreq r0,r0,r2
	streqb r0,vdpstat


	cmp r1,#96
	ldrmi pc,scanlinehook
;@--------------------------------------------- on line 96
	ldrb r0,vdpmode2
	strb r0,vdpmode2_bak		;@ screen on/off


	adr addy,line96_to_VBL
	str addy,z80_nexttimeout
	str addy,z80_nexttimeout_
	ldr pc,scanlinehook
line96_to_VBL ;@------------------------
	ldr r0,cyclesperscanline
	add cycles,cycles,r0

	ldr r1,scanline
	add r1,r1,#1
	str r1,scanline

	cmp r1,#192
	ldrmi pc,scanlinehook
	bleq endframe					;display update, r1 is saved.

	adr addy,lineVBL
	str addy,z80_nexttimeout
	str addy,z80_nexttimeout_
	ldr pc,scanlinehook
lineVBL ;------------------------

	ldr r0,fpsvalue
	add r0,r0,#1
	str r0,fpsvalue
;----------------------------------------
 [ DEBUG
	mov r1,#REG_BASE			;darken screen during EMU vblank
	mov r0,#0x00f1
	strh r0,[r1,#REG_BLDCNT]
	ldrh r0,[r1,#REG_VCOUNT]
	mov r1,#19
	bl debug_
 ]
	ldrb r0,vdpstat
	orr r0,r0,#0x80		;VBlank bit
	strb r0,vdpstat
	ldrb r1,vdpmode2
	tst r1,#0x20		;VBL IRQ enabled?
	strneb r0,z80_irq_pin

	ldr r1,scanline
	add r1,r1,#1
	str r1,scanline

	adr addy,VBL_Hook
	str addy,z80_nexttimeout
	str addy,z80_nexttimeout_
	ldrb r0,[z80pc],#1
	ldr pc,[z80optbl,r0,lsl#2]
VBL_Hook
	ldr r0,cyclesperscanline
	add cycles,cycles,r0

	adr addy,lineVBL_to_end
	str addy,z80_nexttimeout
	str addy,z80_nexttimeout_
	ldr pc,scanlinehook

lineVBL_to_end ;------------------------
	ldr r0,cyclesperscanline
	add cycles,cycles,r0

	ldr r1,scanline
	add r1,r1,#1
	str r1,scanline
	ldr r2,lastscanline
	cmp r1,r2
	ldrmi pc,scanlinehook

	adr addy,line0
	str addy,z80_nexttimeout
	str addy,z80_nexttimeout_
	ldr r0,frame
	add r0,r0,#1
	str r0,frame
	ldr pc,scanlinehook

;----------------------------------------------------------
;checkScanlineIRQ
;	ldrb r1,vdpmode2
;	ldrb r0,vdpstat
;	and r0,r0,#0x80
;	and r0,r0,r1,lsl#2
;	strb r0,z80_irq_pin

;	b Z80_checkMasterIRQ
;----------------------------------------------------------------------------
fiveminutes		DCD 5*60*60
sleeptime		DCD 5*60*60
dontstop		DCB 0
novblankwait	DCB 0
gbadetect		DCB 0
sprcollision	DCB 0
;----------------------------------------------------------------------------
	AREA rom_code, CODE, READONLY
;----------------------------------------------------------------------------
ntsc_pal_reset
;--- PAL Speed - 3546893Hz / 50Hz / 313 = 226.638
;---NTSC Speed - 3579545Hz / 60Hz / 262 = 227.706
	ldr r0,emuflags
	tst r0,#PALTIMING
	moveq r1,#228*CYCLE		;NTSC 228
	movne r1,#228*CYCLE		;PAL 228
	str r1,cyclesperscanline
	ldreq r1,=261			;NTSC
	ldrne r1,=312			;PAL
	str r1,lastscanline
	bx lr
;----------------------------------------------------------------------------
CPU_reset	;called by loadcart (r0-r9 are free to use)
;----------------------------------------------------------------------------
	str lr,[sp,#-4]!

	bl ntsc_pal_reset

	ldr r0,=Z80_checkMasterIRQ
	str r0,scanlinehook

	mov r0,#0				;@ cpu type
	bl Z80_reset
	ldr lr,[sp],#4
	bx lr


;----------------------------------------------------------------------------
	AREA wram_globals2, CODE, READWRITE
;----------------------------------------------------------------------------
	DCD 0 ;scanlinehook
	DCD 0 ;cyclesperscanline
	DCD 0 ;lastscanline (261)
;----------------------------------------------------------------------------
	END

